/* UsiFe FileSystem
----------------
Copyright (2012): Rohan Sharma and Saurabh Kumar

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

CONTACT: 
Rohan Sharma : rickyrohan14@gmail.com
Saurabh Kumar : saurabh.catch@gmail.com
Smruti R. Sarangi : srsarangi@cse.iitd.ac.in
*/



package com.example;

import javax.swing.JOptionPane;
import javax.swing.JDialog;
import javax.swing.JButton;
import javax.swing.JRadioButton;
import javax.swing.ButtonGroup;
import javax.swing.JLabel;
import javax.swing.ImageIcon;
import javax.swing.BoxLayout;
import javax.swing.Box;
import javax.swing.BorderFactory;
import javax.swing.border.Border;
import javax.swing.JTabbedPane;
import javax.swing.JPanel;
import javax.swing.JFrame;
import java.beans.*; //Property change stuff
import java.awt.*;
import java.awt.event.*;
import java.util.StringTokenizer;


public class DIalog2  extends JPanel {
    JLabel label;
    ImageIcon icon = createImageIcon("images/middle.gif");
    JFrame frame;
    String simpleDialogDesc = "Decrypt page";
    
    

    /** Creates the GUI shown inside the frame's content pane. */
    public DIalog2(JFrame frame) {
        super(new BorderLayout());
        this.frame = frame;
       

        //Create the components.
        //JPanel frequentPanel = createSimpleDialogBox();
        JPanel featurePanel = createFeatureDialogBox();
        
        label = new JLabel("",
                           JLabel.CENTER);

        //Lay them out.
        Border padding = BorderFactory.createEmptyBorder(20,20,5,20);
        //frequentPanel.setBorder(padding);
        featurePanel.setBorder(padding);
        

        JTabbedPane tabbedPane = new JTabbedPane();
        tabbedPane.addTab("", null,
                          featurePanel,
                          simpleDialogDesc);
    
    

        add(tabbedPane, BorderLayout.CENTER);
        add(label, BorderLayout.PAGE_END);
        label.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
    }

    /** Sets the text displayed at the bottom of the frame. */
    void setLabel(String newText) {
        label.setText(newText);
    }

    /** Returns an ImageIcon, or null if the path was invalid. */
    protected static ImageIcon createImageIcon(String path) {
        java.net.URL imgURL = DialogDemo.class.getResource(path);
        if (imgURL != null) {
            return new ImageIcon(imgURL);
        } else {
            System.err.println("Couldn't find file: " + path);
            return null;
        }
    }

    /**
     * Used by createSimpleDialogBox and createFeatureDialogBox
     * to create a pane containing a description, a single column
     * of radio buttons, and the Show it! button.
     */
    private JPanel createPane(String description,
                              JRadioButton[] radioButtons,
                              JButton showButton) {

        int numChoices = radioButtons.length;
        JPanel box = new JPanel();
        JLabel label = new JLabel(description);

        box.setLayout(new BoxLayout(box, BoxLayout.PAGE_AXIS));
        box.add(label);

        for (int i = 0; i < numChoices; i++) {
            box.add(radioButtons[i]);
        }

        JPanel pane = new JPanel(new BorderLayout());
        pane.add(box, BorderLayout.PAGE_START);
        pane.add(showButton, BorderLayout.PAGE_END);
        return pane;
    }

    /** Creates the panel shown by the second tab. */
    private JPanel createFeatureDialogBox() {
        final int numButtons = 7;
        JRadioButton[] radioButtons = new JRadioButton[numButtons];
        final ButtonGroup group = new ButtonGroup();

        JButton showItButton = null;


        String priLevelsData=UsifeNew.getUsifeData("PrivilegeLevels");
        StringTokenizer priLevels=new StringTokenizer(priLevelsData,":");


        final String HR = priLevels.nextToken();
        final String Technical = priLevels.nextToken();
        final String Manager = priLevels.nextToken();
        final String CL1 = priLevels.nextToken();
        final String CL2 = priLevels.nextToken();
        final String CL3 = priLevels.nextToken();
        final String CL4 = priLevels.nextToken();


        radioButtons[0] = new JRadioButton(HR);
        radioButtons[0].setActionCommand(HR);

        radioButtons[1] = new JRadioButton(Technical);
        radioButtons[1].setActionCommand(Technical);

        radioButtons[2] = new JRadioButton(Manager);
        radioButtons[2].setActionCommand(Manager);

        radioButtons[3] = new JRadioButton(CL1);
        radioButtons[3].setActionCommand(CL1);

        radioButtons[4] = new JRadioButton(CL2);
        radioButtons[4].setActionCommand(CL2);

        radioButtons[5] = new JRadioButton(CL3);
        radioButtons[5].setActionCommand(CL3);

        radioButtons[6] = new JRadioButton(CL4);
        radioButtons[6].setActionCommand(CL4);

        for (int i = 0; i < numButtons; i++) {
            group.add(radioButtons[i]);
        }
        radioButtons[0].setSelected(true);

        showItButton = new JButton("Proceed!");
        showItButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                String command = group.getSelection().getActionCommand();
                UsifeNew.reset();
                //pick one of many

                 String usifeData=UsifeNew.getUsifeData("UsifeData");
                    StringTokenizer st = new StringTokenizer(usifeData, ";");
                    String tmp1;
                    if(st.hasMoreTokens()) {
                        tmp1=st.nextToken();
                    } else{
                         tmp1=" ";
                     }
                    String tmp2;
                    if(st.hasMoreTokens()) {
                        tmp2=st.nextToken();
                    } else{
                         tmp2=" ";
                     }

                    String tmp3;
                    if(st.hasMoreTokens()) {
                        tmp3=st.nextToken();
                    } else{
                         tmp3=" ";
                     }

                String tmp4;
                    if(st.hasMoreTokens()) {
                        tmp4=st.nextToken();
                    } else{
                         tmp4=" ";
                     }
                String tmp5;
                    if(st.hasMoreTokens()) {
                        tmp5=st.nextToken();
                    } else{
                         tmp5=" ";
                     }

                String tmp6;
                    if(st.hasMoreTokens()) {
                        tmp6=st.nextToken();
                    } else{
                         tmp6=" ";
                     }

               String tmp7;
                    if(st.hasMoreTokens()) {
                        tmp7=st.nextToken();
                    } else{
                         tmp7=" ";
                     }



                if (command == HR) {

                   String s = (String)JOptionPane.showInputDialog(
                                        frame,
                                        "Enter Key",
                                        "Key",
                                        JOptionPane.PLAIN_MESSAGE,
                                        icon,
                                        null,
                                        null);

                      if(s==null)
                          return;

                            StringTokenizer st1 = new StringTokenizer(tmp1, ",");
                            try {
                                while(st1.hasMoreTokens()) {
                                    int tmp=Integer.parseInt(st1.nextToken());
                                    System.out.println("Encrypting page "+tmp+" key "+s);
                                    UsifeNew.decryptPage(tmp, s);
                                    UsifeNew.unHidePage(tmp);
                                }
                            } catch (Exception ex) {
                                //error=1;
                                //continue;
                                return;
                            }




                        return;


                //non-auto-closing dialog
                } else if (command == Technical) {
                   String s = (String)JOptionPane.showInputDialog(
                                        frame,
                                        "Enter Key",
                                        "Key",
                                        JOptionPane.PLAIN_MESSAGE,
                                        icon,
                                        null,
                                        null);

                      if(s==null)
                          return;

                            StringTokenizer st1 = new StringTokenizer(tmp2, ",");
                            try {
                                while(st1.hasMoreTokens()) {
                                    int tmp=Integer.parseInt(st1.nextToken());
                                    System.out.println("Encrypting page "+tmp+" key "+s);
                                    UsifeNew.decryptPage(tmp, s);
                                    UsifeNew.unHidePage(tmp);
                                }
                            } catch (Exception ex) {
                                //error=1;
                                //continue;
                                return;
                            }


                        return;
                } else if (command == Manager) {
                   String s = (String)JOptionPane.showInputDialog(
                                        frame,
                                        "Enter Key",
                                        "Key",
                                        JOptionPane.PLAIN_MESSAGE,
                                        icon,
                                        null,
                                        null);

                      if(s==null)
                          return;

                            StringTokenizer st1 = new StringTokenizer(tmp3, ",");
                            try {
                                while(st1.hasMoreTokens()) {
                                    int tmp=Integer.parseInt(st1.nextToken());
                                    System.out.println("Encrypting page "+tmp+" key "+s);
                                    UsifeNew.decryptPage(tmp, s);
                                    UsifeNew.unHidePage(tmp);
                                }
                            } catch (Exception ex) {
                                //error=1;
                                //continue;
                                return;
                            }


                        return;
                } else if (command == CL1) {
                   String s = (String)JOptionPane.showInputDialog(
                                        frame,
                                        "Enter Key",
                                        "Key",
                                        JOptionPane.PLAIN_MESSAGE,
                                        icon,
                                        null,
                                        null);

                      if(s==null)
                          return;

                            StringTokenizer st1 = new StringTokenizer(tmp4, ",");
                            try {
                                while(st1.hasMoreTokens()) {
                                    int tmp=Integer.parseInt(st1.nextToken());
                                    System.out.println("Encrypting page "+tmp+" key "+s);
                                    UsifeNew.decryptPage(tmp, s);
                                    UsifeNew.unHidePage(tmp);
                                }
                            } catch (Exception ex) {
                                //error=1;
                                //continue;
                                return;
                            }


                        return;
                } else if (command == CL2) {
                   String s = (String)JOptionPane.showInputDialog(
                                        frame,
                                        "Enter Key",
                                        "Key",
                                        JOptionPane.PLAIN_MESSAGE,
                                        icon,
                                        null,
                                        null);

                      if(s==null)
                          return;

                            StringTokenizer st1 = new StringTokenizer(tmp5, ",");
                            try {
                                while(st1.hasMoreTokens()) {
                                    int tmp=Integer.parseInt(st1.nextToken());
                                    System.out.println("Encrypting page "+tmp+" key "+s);
                                    UsifeNew.decryptPage(tmp, s);
                                    UsifeNew.unHidePage(tmp);
                                }
                            } catch (Exception ex) {
                                //error=1;
                                //continue;
                                return;
                            }


                        return;
                } else if (command == CL3) {
                   String s = (String)JOptionPane.showInputDialog(
                                        frame,
                                        "Enter Key",
                                        "Key",
                                        JOptionPane.PLAIN_MESSAGE,
                                        icon,
                                        null,
                                        null);

                      if(s==null)
                          return;

                            StringTokenizer st1 = new StringTokenizer(tmp6, ",");
                            try {
                                while(st1.hasMoreTokens()) {
                                    int tmp=Integer.parseInt(st1.nextToken());
                                    System.out.println("Encrypting page "+tmp+" key "+s);
                                    UsifeNew.decryptPage(tmp, s);
                                    UsifeNew.unHidePage(tmp);
                                }
                            } catch (Exception ex) {
                                //error=1;
                                //continue;
                                return;
                            }


                        return;
                } else if (command == CL4) {
                   String s = (String)JOptionPane.showInputDialog(
                                        frame,
                                        "Enter Key",
                                        "Key",
                                        JOptionPane.PLAIN_MESSAGE,
                                        icon,
                                        null,
                                        null);

                      if(s==null)
                          return;

                            StringTokenizer st1 = new StringTokenizer(tmp7, ",");
                            try {
                                while(st1.hasMoreTokens()) {
                                    int tmp=Integer.parseInt(st1.nextToken());
                                    System.out.println("Decrypting page "+tmp+" key "+s+" "+tmp7);
                                    UsifeNew.decryptPage(tmp, s);
                                    UsifeNew.unHidePage(tmp);
                                }
                            } catch (Exception ex) {
                                //error=1;
                                //continue;
                                return;
                            }


                        return;
                }




            }
        });

        return createPane(simpleDialogDesc + ":",
                          radioButtons,
                          showItButton);
    }


    /**
     * Create the GUI and show it.  For thread safety,
     * this method should be invoked from the
     * event-dispatching thread.
     */
    private static void createAndShowGUI() {
        //Create and set up the window.
        JFrame frame = new JFrame("");
        //frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        //Create and set up the content pane.
        DIalog2 newContentPane = new DIalog2(frame);
        newContentPane.setOpaque(true); //content panes must be opaque
        frame.setContentPane(newContentPane);

        //Display the window.
        frame.pack();
        frame.setVisible(true);
    }

    public static void StartDialog() {
        //Schedule a job for the event-dispatching thread:
        //creating and showing this application's GUI.
        javax.swing.SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                createAndShowGUI();
            }
        });
    }

}

