/* UsiFe FileSystem
----------------
Copyright (2012): Rohan Sharma and Saurabh Kumar

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

CONTACT: 
Rohan Sharma : rickyrohan14@gmail.com
Saurabh Kumar : saurabh.catch@gmail.com
Smruti R. Sarangi : srsarangi@cse.iitd.ac.in
*/

package com.example;

import com.sun.star.io.IOException;
import com.sun.star.lang.IllegalArgumentException;
import com.sun.star.lang.IndexOutOfBoundsException;
import com.sun.star.lang.WrappedTargetException;
import com.sun.star.uno.UnoRuntime;
import com.sun.star.uno.XComponentContext;
import com.sun.star.lib.uno.helper.Factory;
import com.sun.star.lang.XSingleComponentFactory;
import com.sun.star.registry.XRegistryKey;
import com.sun.star.lib.uno.helper.WeakBase;
import com.sun.star.presentation.*;
import com.sun.star.document.*;
import com.sun.star.text.*;
import com.sun.star.frame.*;
import com.sun.star.container.*;
import com.sun.star.drawing.*;
import com.sun.star.beans.*;
import java.util.logging.Level;
import java.util.logging.Logger;
import com.sun.star.awt.XDialog;
import com.sun.star.lang.XMultiComponentFactory;

public final class UsifeNew extends WeakBase
   implements com.sun.star.lang.XInitialization,
              com.sun.star.frame.XDispatch,
              com.sun.star.lang.XServiceInfo,
              com.sun.star.frame.XDispatchProvider
{
    private final XComponentContext m_xContext;
    private com.sun.star.frame.XFrame m_xFrame;
    private static final String m_implementationName = UsifeNew.class.getName();
    private static final String[] m_serviceNames = {
        "com.sun.star.frame.ProtocolHandler" };

    /////////////////////

    int mode;
    int noOfPages;
    static com.sun.star.lang.XComponent xDrawDoc;
    static com.sun.star.drawing.XDrawPage xDrawPage;
    static com.sun.star.drawing.XDrawPage newPage;
    static com.sun.star.frame.XDesktop desktop;
    static XDocumentPropertiesSupplier xDocInfoSuppl;
    static XDocumentProperties xDP;
    static XPropertyContainer udpc;
    static XPropertySet udps;
    static XPropertySetInfo udpsInfo;
    static com.sun.star.drawing.XDrawPages xDPn;
    static com.sun.star.container.XIndexAccess xDPi;
    static com.sun.star.drawing.XDrawPagesSupplier xDPS;
    static com.sun.star.drawing.XDrawPageDuplicator xDPd;
    static com.sun.star.drawing.XDrawPage xPages[];

    static int inited;
    //////////////////////


    public UsifeNew( XComponentContext context )
    {
        m_xContext = context;
        mode=1;
        xPages=new com.sun.star.drawing.XDrawPage[100];
        if(inited==0)  {
        desktop = getDesktop(m_xContext);
        xDrawDoc = desktop.getCurrentComponent();

        xDocInfoSuppl = (XDocumentPropertiesSupplier) UnoRuntime.queryInterface(XDocumentPropertiesSupplier.class, xDrawDoc);

        xDP = xDocInfoSuppl.getDocumentProperties();

        udpc = xDP.getUserDefinedProperties();


        udps = (XPropertySet) UnoRuntime.queryInterface(XPropertySet.class, udpc);
        udpsInfo = (XPropertySetInfo) udps.getPropertySetInfo();



         xDPS =
                (com.sun.star.drawing.XDrawPagesSupplier)UnoRuntime.queryInterface(
                    com.sun.star.drawing.XDrawPagesSupplier.class, xDrawDoc);
         xDPn = xDPS.getDrawPages();

         xDPi =
                (com.sun.star.container.XIndexAccess)UnoRuntime.queryInterface(
                    com.sun.star.container.XIndexAccess.class, xDPn);




        xDPd = (com.sun.star.drawing.XDrawPageDuplicator)UnoRuntime.queryInterface(
                        com.sun.star.drawing.XDrawPageDuplicator.class, xDrawDoc);


            

        }

         inited=1;


    };


    public  static void reset(  )
    {
        
        
        xDrawDoc = desktop.getCurrentComponent();

        xDocInfoSuppl = (XDocumentPropertiesSupplier) UnoRuntime.queryInterface(XDocumentPropertiesSupplier.class, xDrawDoc);

        xDP = xDocInfoSuppl.getDocumentProperties();

        udpc = xDP.getUserDefinedProperties();


        udps = (XPropertySet) UnoRuntime.queryInterface(XPropertySet.class, udpc);
        udpsInfo = (XPropertySetInfo) udps.getPropertySetInfo();



         xDPS =
                (com.sun.star.drawing.XDrawPagesSupplier)UnoRuntime.queryInterface(
                    com.sun.star.drawing.XDrawPagesSupplier.class, xDrawDoc);
         xDPn = xDPS.getDrawPages();

         xDPi =
                (com.sun.star.container.XIndexAccess)UnoRuntime.queryInterface(
                    com.sun.star.container.XIndexAccess.class, xDPn);




        xDPd = (com.sun.star.drawing.XDrawPageDuplicator)UnoRuntime.queryInterface(
                        com.sun.star.drawing.XDrawPageDuplicator.class, xDrawDoc);
            if(getUsifeData("PrivilegeLevels").compareTo("")==0) {
                setUsifeData("PrivilegeLevels","HR:Technical:Manager:CustomLabel1:CustomLabel2:CustomLabel3:CustomLabel4");
                System.out.println("privilege levels set");
            }


    }

    public static XSingleComponentFactory __getComponentFactory( String sImplementationName ) {
        XSingleComponentFactory xFactory = null;

        if ( sImplementationName.equals( m_implementationName ) )
            xFactory = Factory.createComponentFactory(UsifeNew.class, m_serviceNames);
        return xFactory;
    }

    public static boolean __writeRegistryServiceInfo( XRegistryKey xRegistryKey ) {
        return Factory.writeRegistryServiceInfo(m_implementationName,
                                                m_serviceNames,
                                                xRegistryKey);
    }

     public static com.sun.star.frame.XDesktop getDesktop(com.sun.star.uno.XComponentContext xContext) {
        com.sun.star.frame.XDesktop xDesktop = null;
        com.sun.star.lang.XMultiComponentFactory xMCF = null;

        try {


            // get the remote office service manager
            xMCF = xContext.getServiceManager();
            if( xMCF != null ) {
                System.out.println("Connected to a running office ...");

                Object oDesktop = xMCF.createInstanceWithContext(
                    "com.sun.star.frame.Desktop", xContext);
                xDesktop = (com.sun.star.frame.XDesktop) UnoRuntime.queryInterface(
                    com.sun.star.frame.XDesktop.class, oDesktop);
            }
            else
                System.out.println( "Can't create a desktop. No connection, no remote office servicemanager available!" );
        }
        catch( Exception e) {
            e.printStackTrace(System.err);
            System.exit(1);
        }
        return xDesktop;
    }



    // com.sun.star.lang.XInitialization:
    public void initialize( Object[] object )
        throws com.sun.star.uno.Exception
    {
        if ( object.length > 0 )
        {
            m_xFrame = (com.sun.star.frame.XFrame)UnoRuntime.queryInterface(
                com.sun.star.frame.XFrame.class, object[0]);
        }


    }



    public static void encryptPage(int page,String key) {
        try {
                xDrawPage = (com.sun.star.drawing.XDrawPage) UnoRuntime.queryInterface(
                                com.sun.star.drawing.XDrawPage.class, xDPi.getByIndex(page-1));
                } catch (IndexOutOfBoundsException ex) {
                    Logger.getLogger(UsifeNew.class.getName()).log(Level.SEVERE, null, ex);
                } catch (WrappedTargetException ex) {
                    Logger.getLogger(UsifeNew.class.getName()).log(Level.SEVERE, null, ex);
                }

                XShapes xShapes = (XShapes)UnoRuntime.queryInterface(XShapes.class, xDrawPage);
                int shapesCount=xShapes.getCount();
                

                for(int i=0;i<shapesCount;i++) {
                    try {

                         XShape tmp = (XShape)UnoRuntime.queryInterface(XShape.class, xShapes.getByIndex(i));
                         XText xText = (XText)UnoRuntime.queryInterface(XText.class, tmp);
                        XTextRange xTextRange = (XTextRange)UnoRuntime.queryInterface(XTextRange.class, xText);
                        String str=xTextRange.getString();
                        

                        // Create encrypter/decrypter class
                        StringEncrypter desEncrypter = new StringEncrypter(key);

                        // Encrypt the string
                        //String desEncrypted       = desEncrypter.encrypt(secretString);

                        //String newstr=new String(ar);
                        xTextRange.setString(desEncrypter.encrypt(str));
                        //xTextCursor.gotoEnd(true);

                    } catch (IndexOutOfBoundsException ex) {
                        Logger.getLogger(UsifeNew.class.getName()).log(Level.SEVERE, null, ex);
                    } catch (WrappedTargetException ex) {
                        Logger.getLogger(UsifeNew.class.getName()).log(Level.SEVERE, null, ex);
                    }

        }
        
    }



    public static void decryptPage(int page,String key) {
        try {
                xDrawPage = (com.sun.star.drawing.XDrawPage) UnoRuntime.queryInterface(
                                com.sun.star.drawing.XDrawPage.class, xDPi.getByIndex(page-1));
                } catch (IndexOutOfBoundsException ex) {
                    Logger.getLogger(UsifeNew.class.getName()).log(Level.SEVERE, null, ex);
                } catch (WrappedTargetException ex) {
                    Logger.getLogger(UsifeNew.class.getName()).log(Level.SEVERE, null, ex);
                }

                XShapes xShapes = (XShapes)UnoRuntime.queryInterface(XShapes.class, xDrawPage);
                int shapesCount=xShapes.getCount();


                for(int i=0;i<shapesCount;i++) {
                    try {

                         XShape tmp = (XShape)UnoRuntime.queryInterface(XShape.class, xShapes.getByIndex(i));
                         XText xText = (XText)UnoRuntime.queryInterface(XText.class, tmp);
                        XTextRange xTextRange = (XTextRange)UnoRuntime.queryInterface(XTextRange.class, xText);
                        String str=xTextRange.getString();


                        // Create encrypter/decrypter class
                        StringEncrypter desEncrypter = new StringEncrypter(key);

                        // Encrypt the string
                        //String desEncrypted       = desEncrypter.encrypt(secretString);

                        //String newstr=new String(ar);
                        xTextRange.setString(desEncrypter.decrypt(str));
                        //xTextCursor.gotoEnd(true);

                    } catch (IndexOutOfBoundsException ex) {
                        Logger.getLogger(UsifeNew.class.getName()).log(Level.SEVERE, null, ex);
                    } catch (WrappedTargetException ex) {
                        Logger.getLogger(UsifeNew.class.getName()).log(Level.SEVERE, null, ex);
                    }

        }

    }



    public static String getUsifeData(String property) {
        String res=new String("");

        if(udpsInfo.hasPropertyByName(property)) {


                            try {
                         res = udps.getPropertyValue(property).toString();

                            } catch (UnknownPropertyException ex) {
                                Logger.getLogger(UsifeNew.class.getName()).log(Level.SEVERE, null, ex);
                            } catch (WrappedTargetException ex) {
                        Logger.getLogger(UsifeNew.class.getName()).log(Level.SEVERE, null, ex);
                    }

        }
        return res;
    }


    public static void setUsifeData(String property, String data) {

        if(udpsInfo.hasPropertyByName(property)) {
                   try {
                            try {
                                udps.setPropertyValue(property, data);
                            } catch (PropertyVetoException ex) {
                                Logger.getLogger(UsifeNew.class.getName()).log(Level.SEVERE, null, ex);
                            } catch (IllegalArgumentException ex) {
                                Logger.getLogger(UsifeNew.class.getName()).log(Level.SEVERE, null, ex);
                            }

                        } catch (UnknownPropertyException ex) {
                            Logger.getLogger(UsifeNew.class.getName()).log(Level.SEVERE, null, ex);
                        } catch (WrappedTargetException ex) {
                            Logger.getLogger(UsifeNew.class.getName()).log(Level.SEVERE, null, ex);
                        }

        } else {
                    try {
                        udpc.addProperty(property, (short) 1, data);
                        save();
                        udps.setPropertyValue(property, data);
                        
                    } catch (UnknownPropertyException ex) {
                Logger.getLogger(UsifeNew.class.getName()).log(Level.SEVERE, null, ex);
            } catch (PropertyVetoException ex) {
                Logger.getLogger(UsifeNew.class.getName()).log(Level.SEVERE, null, ex);
            } catch (WrappedTargetException ex) {
                Logger.getLogger(UsifeNew.class.getName()).log(Level.SEVERE, null, ex);
            } catch (PropertyExistException ex) {
                        Logger.getLogger(UsifeNew.class.getName()).log(Level.SEVERE, null, ex);
                    } catch (IllegalTypeException ex) {
                        Logger.getLogger(UsifeNew.class.getName()).log(Level.SEVERE, null, ex);
                    } catch (IllegalArgumentException ex) {
                        Logger.getLogger(UsifeNew.class.getName()).log(Level.SEVERE, null, ex);
                    }

        }
    }

        public static void hidePage(int page) {
        try {
                xDrawPage = (com.sun.star.drawing.XDrawPage) UnoRuntime.queryInterface(
                                com.sun.star.drawing.XDrawPage.class, xDPi.getByIndex(page-1));
                } catch (IndexOutOfBoundsException ex) {
                    Logger.getLogger(UsifeNew.class.getName()).log(Level.SEVERE, null, ex);
                } catch (WrappedTargetException ex) {
                    Logger.getLogger(UsifeNew.class.getName()).log(Level.SEVERE, null, ex);
                }
                XPropertySet tmp= (XPropertySet) UnoRuntime.queryInterface(
                                com.sun.star.beans.XPropertySet.class, xDrawPage);
        try {
            tmp.setPropertyValue("Visible", false);
        } catch (UnknownPropertyException ex) {
            Logger.getLogger(UsifeNew.class.getName()).log(Level.SEVERE, null, ex);
        } catch (PropertyVetoException ex) {
            Logger.getLogger(UsifeNew.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IllegalArgumentException ex) {
            Logger.getLogger(UsifeNew.class.getName()).log(Level.SEVERE, null, ex);
        } catch (WrappedTargetException ex) {
            Logger.getLogger(UsifeNew.class.getName()).log(Level.SEVERE, null, ex);
        }


        }



public static void unHidePage(int page) {
        try {
                xDrawPage = (com.sun.star.drawing.XDrawPage) UnoRuntime.queryInterface(
                                com.sun.star.drawing.XDrawPage.class, xDPi.getByIndex(page-1));
                } catch (IndexOutOfBoundsException ex) {
                    Logger.getLogger(UsifeNew.class.getName()).log(Level.SEVERE, null, ex);
                } catch (WrappedTargetException ex) {
                    Logger.getLogger(UsifeNew.class.getName()).log(Level.SEVERE, null, ex);
                }
                XPropertySet tmp= (XPropertySet) UnoRuntime.queryInterface(
                                com.sun.star.beans.XPropertySet.class, xDrawPage);
        try {
            tmp.setPropertyValue("Visible", true);
        } catch (UnknownPropertyException ex) {
            Logger.getLogger(UsifeNew.class.getName()).log(Level.SEVERE, null, ex);
        } catch (PropertyVetoException ex) {
            Logger.getLogger(UsifeNew.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IllegalArgumentException ex) {
            Logger.getLogger(UsifeNew.class.getName()).log(Level.SEVERE, null, ex);
        } catch (WrappedTargetException ex) {
            Logger.getLogger(UsifeNew.class.getName()).log(Level.SEVERE, null, ex);
        }


    }

    

public static void save() {
      XStorable xStorable = (XStorable)UnoRuntime.queryInterface(XStorable.class, xDrawDoc);
                try {
                    xStorable.store();
                } catch (IOException ex) {
                    Logger.getLogger(UsifeNew.class.getName()).log(Level.SEVERE, null, ex);
                }

}


public static Object getCurrentPage() {
        com.sun.star.frame.XModel x = (com.sun.star.frame.XModel)UnoRuntime.queryInterface(com.sun.star.frame.XModel.class, xDrawDoc);
                com.sun.star.frame.XController xco=x.getCurrentController();
                com.sun.star.drawing.XDrawView xdv=(com.sun.star.drawing.XDrawView)UnoRuntime.queryInterface(com.sun.star.drawing.XDrawView.class, xco);
                //System.out.println(xdv.getCurrentPage());
                XDrawPage  currentPage=xdv.getCurrentPage();
                XPropertySet xPropertySet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, currentPage);
                try {
                    return xPropertySet.getPropertyValue("Number");
                } catch (UnknownPropertyException ex) {
                    Logger.getLogger(UsifeNew.class.getName()).log(Level.SEVERE, null, ex);
                } catch (WrappedTargetException ex) {
                    Logger.getLogger(UsifeNew.class.getName()).log(Level.SEVERE, null, ex);
                }
                return 0;

}

    // com.sun.star.frame.XDispatch:
     public void dispatch( com.sun.star.util.URL aURL,
                           com.sun.star.beans.PropertyValue[] aArguments )
    {
         if ( aURL.Protocol.compareTo("com.example.usifenew:") == 0 )
        {
            if ( aURL.Path.compareTo("Command0") == 0 )
            {
                // add your own code here
                reset();
                DialogDemo.StartDialog();
                return;
            }

            if ( aURL.Path.compareTo("Command1") == 0 )
            {
               UsifeNew.setUsifeData("UsifeData","");
               UsifeNew.setUsifeData("PrivilegeLevels","");
            }


            if ( aURL.Path.compareTo("Command2") == 0 )
            {
                // add your own code here
                reset();
                com.sun.star.frame.XModel x = (com.sun.star.frame.XModel)UnoRuntime.queryInterface(com.sun.star.frame.XModel.class, xDrawDoc);
                com.sun.star.frame.XController xco=x.getCurrentController();
                com.sun.star.drawing.XDrawView xdv=(com.sun.star.drawing.XDrawView)UnoRuntime.queryInterface(com.sun.star.drawing.XDrawView.class, xco);
                //System.out.println(xdv.getCurrentPage());
                XDrawPage  currentPage=xdv.getCurrentPage();
                XPropertySet xPropertySet = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, currentPage);
                try {
                    System.out.println(xPropertySet.getPropertyValue("Number"));
                } catch (UnknownPropertyException ex) {
                    Logger.getLogger(UsifeNew.class.getName()).log(Level.SEVERE, null, ex);
                } catch (WrappedTargetException ex) {
                    Logger.getLogger(UsifeNew.class.getName()).log(Level.SEVERE, null, ex);
                }

                DIalog2.StartDialog();
                return;
            }



            if ( aURL.Path.compareTo("Command3") == 0 )
            {
                // add your own code here
                reset();
               
                Dialog3.StartDialog();
                return;
            }



        }
    }

    public void addStatusListener( com.sun.star.frame.XStatusListener xControl,
                                    com.sun.star.util.URL aURL )
    {
        // add your own code here
    }

    public void removeStatusListener( com.sun.star.frame.XStatusListener xControl,
                                       com.sun.star.util.URL aURL )
    {
        // add your own code here
    }

    // com.sun.star.lang.XServiceInfo:
    public String getImplementationName() {
         return m_implementationName;
    }

    public boolean supportsService( String sService ) {
        int len = m_serviceNames.length;

        for( int i=0; i < len; i++) {
            if (sService.equals(m_serviceNames[i]))
                return true;
        }
        return false;
    }

    public String[] getSupportedServiceNames() {
        return m_serviceNames;
    }

    // com.sun.star.frame.XDispatchProvider:
    public com.sun.star.frame.XDispatch queryDispatch( com.sun.star.util.URL aURL,
                                                       String sTargetFrameName,
                                                       int iSearchFlags )
    {
        if ( aURL.Protocol.compareTo("com.example.usifenew:") == 0 )
        {
            if ( aURL.Path.compareTo("Command0") == 0 )
                return this;
            if ( aURL.Path.compareTo("Command1") == 0 )
                return this;
            if ( aURL.Path.compareTo("Command2") == 0 )
                return this;
            if ( aURL.Path.compareTo("Command3") == 0 )
                return this;
        }
        return null;
    }

    // com.sun.star.frame.XDispatchProvider:
    public com.sun.star.frame.XDispatch[] queryDispatches(
         com.sun.star.frame.DispatchDescriptor[] seqDescriptors )
    {
        int nCount = seqDescriptors.length;
        com.sun.star.frame.XDispatch[] seqDispatcher =
            new com.sun.star.frame.XDispatch[seqDescriptors.length];

        for( int i=0; i < nCount; ++i )
        {
            seqDispatcher[i] = queryDispatch(seqDescriptors[i].FeatureURL,
                                             seqDescriptors[i].FrameName,
                                             seqDescriptors[i].SearchFlags );
        }
        return seqDispatcher;
    }

}
